<?php

namespace EventPortal\Tests\Support\Factories;

use EventPortal\Domain\Permission\Models\Group;
use EventPortal\Domain\Permission\Models\Permission;
use EventPortal\Domain\Permission\Models\Role;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Str;

class PermissionFactory
{
    public static function makeWithRoleAndGroup(int $amount = 5): Collection
    {
        $roleName = "Role with {$amount}";
        $groupName = "Group with {$amount}";
        $role = factory(Role::class)->create(['name' => $roleName, 'slug' => Str::slug($roleName)]);
        $group = factory(Group::class)->create(['name' => $groupName, 'slug' => Str::slug($groupName)]);
        return factory(Permission::class, $amount)
            ->state('default')
            ->create()
            ->each(function (Permission $permission) use ($role, $group): void {
                $role->permissions()->attach($permission->id);
                $group->permissions()->attach($permission->id);
            });
    }
}
